{-----------------------------------------------------------------------------}
{   Code source  utilis dans la leon 7 du Guide Pratique de
{   la programmation de directshow sous delphi publi par Paul Glagla
{   sur le site http://paul.glagla.free.fr
{
{-----------------------------------------------------------------------------}
unit main;

{-----------------------------------------------------------------------------}
interface

{-----------------------------------------------------------------------------}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,DSPack,directshow9,grf;

{-----------------------------------------------------------------------------}
type
  TForm1 = class(TForm)
    SaveBtn: TBitBtn;
    LoadBtn: TBitBtn;
    fg: TFilterGraph;
    CloseBtn: TBitBtn;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    OpenDialog2: TOpenDialog;
    Memo1: TMemo;
    procedure SaveBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

{-----------------------------------------------------------------------------}
var
  Form1: TForm1;

{-----------------------------------------------------------------------------}
implementation

{$R *.dfm}

{-----------------------------------------------------------------------------}
procedure TForm1.SaveBtnClick(Sender: TObject);
begin
color:=clBtnFace;
with opendialog2 do
   if execute then begin
   fg.RenderFile(filename);
   fg.Pause;
end;
with savedialog1 do 
  if execute then begin
  if savegrf(filename,fg) then color:=clGreen else color:=clRed;
  fg.stop;
end;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.LoadBtnClick(Sender: TObject);
begin
color:=clBtnFace;
with opendialog1 do
  if execute then begin
  if loadGRF(filename,fg) then color:=clGreen else color:=clRed;
  fg.Play;
end;//with if
end;
{-----------------------------------------------------------------------------}
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
fg.ClearGraph;
fg.active:=false;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.FormCreate(Sender: TObject);
begin
fg.Active:=true;
end;

{-----------------------------------------------------------------------------}

end.
